"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getWorkspacesOrderByDependencies = void 0;

var _getWorkspaceDependencies = require("./getWorkspaceDependencies");

var _sortPackagesByDependencies = require("./sortPackagesByDependencies");

const getWorkspacesOrderByDependencies = async ({
  argv,
  workspacePaths
}) => {
  if (workspacePaths.length <= 1) {
    return workspacePaths;
  }

  const promises = workspacePaths.map(async (path, _, paths) => {
    const dependencyPaths = await (0, _getWorkspaceDependencies.getWorkspaceDependencies)({
      argv,
      workspacePath: path,
      workspacePaths: paths
    });
    return [path, dependencyPaths];
  });
  return (await Promise.all(promises)).sort(_sortPackagesByDependencies.sortPackagesByDependencies).map(([k]) => k);
};

exports.getWorkspacesOrderByDependencies = getWorkspacesOrderByDependencies;